# How to contribute to `classy`?

Everything you do for the community of `classy` is a valuable contribution! This includes:

- 🐞 Reporting bug fixes
- :zap: Proposing new features
- :scroll: Improving the docs
- :book: Adding [examples](https://github.com/sunglasses-ai/classy-examples)
- :question: Solving open issues

### 🐞 Did you find a bug?

First, please [quickly search](https://github.com/sunglasses-ai/classy/issues) our issues to see whether it was already reported, in which case you could comment on the existing issue.

Otherwise, open [a new GitHub issue](https://github.com/sunglasses-ai/classy/issues/new). 

Ideally, your issue's title should briefly describe the bug, while the description should contain as much relevant information as possible:
- a minimal example to reproduce the issue
- the observed behaviour
- the expected behaviour
- environment information (classy, pytorch, pytorch-lightning, huggingface & any relevant package versions, NVIDIA driver version)
- [*optional*] a code sample / test case / example demonstrating the expected behaviour

### :zap: Do you have a suggestion for an enhancement?

We track enhancement requests via GitHub issues. Similarly as for bugs, **before you create a new issue**, please [quickly search](https://github.com/sunglasses-ai/classy/issues) our issues to see whether it was suggested already, in which case you would comment on the existing issue (even to suggest improvement / changes or to help us with reviewing the code!). 

When creating your enhancement request, please:

- Provide a clear title and description.
- Provide a brief explanation of why the enhancement would be useful, possibly with examples.
- If you're not sure of how you would go about it, be more vague and request an open discussion of the feature design / implementation.

### :scroll: Improving the docs

Did you find a mistake or do you want to improve the current documentation in some way? Again, thank you! Documentation and examples are what makes a software really usable, and you are contributing to making `classy` a better framework this way. You can simply open a new issue with the section(s) that you would want to work on / see improved, and we'll get there together.

### :book: Do you have an example you want to share?

Please head over to [sunglasses-ai/classy-examples](https://github.com/sunglasses-ai/classy-examples) and follow the guides there.
If you have any troubles making a contribution there, open [a new issue there](https://github.com/sunglasses-ai/classy-examples/issues/new) and we'll be in touch as soon as possible!

### :question: Solving open issues

Did you stumble onto something (a feature request, a bug, a question) you think you could provide a solution / answer to? Please do!
Anyone is more than welcome to collaborate and contribute in as many ways as possible, and we thank every contributor for their effort in making `classy` a better framework.
